﻿using BuildProcess.Views;
using Prism.DryIoc;
using Prism.Ioc;
using Prism.Modularity;
using Prism.Mvvm;
using S7NetModule.Views;
using System.Windows;

namespace BuildProcess
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : PrismApplication
    {
        protected override Window CreateShell()
        {
            return Container.Resolve<MainWindow>();
        }

        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterSingleton<MainWindow>();
            containerRegistry.RegisterForNavigation<LiveChartsView>();
        }

        protected override void ConfigureModuleCatalog(IModuleCatalog moduleCatalog)
        {
            moduleCatalog.AddModule<FlowChartModule.FlowChartModuleModule>();
            moduleCatalog.AddModule<SettingModule.SettingModuleModule>();
            moduleCatalog.AddModule<TcpClientModule.TcpClientModuleModule>();
            moduleCatalog.AddModule<TcpModbusMasterModule.TcpModbusMasterModuleModule>();
            moduleCatalog.AddModule<TcpModbusSlaveModule.TcpModbusSlaveModuleModule>();
            moduleCatalog.AddModule<TcpServerModule.TcpServerModuleModule>();
            moduleCatalog.AddModule<S7NetModule.S7NetModuleModule>();
            moduleCatalog.AddModule<LogicalElement.LogicalElementModule>();
        }
    }
}
