﻿using CommonUtils.Log4;
using CommonUtils.Tcp.TcpSocket;
using CommonUtils.内部存储;
using CommonUtils.运行信号量;
using CustomModule.ViewModels;
using FlowChartModule.绘制模块;
using ParentService.ParentService;
using Prism.Commands;
using Prism.Ioc;
using Prism.Mvvm;
using Prism.Regions;
using S7.Net.Types;
using S7NetModule.Model;
using S7NetModule.S7;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using TcpClientModule.Model;
using TcpClientModule.ViewModels;

namespace BuildProcess.ViewModels
{
    public class MainWindowViewModel : BindableBase
    {
        private string _title = "Prism Application";

        private IContainerProvider _container;

        private IRegionManager _regionManager;
        private DelegateCommand<Canvas> _LoadCommand;

        public DelegateCommand<Canvas> LoadCommand => _LoadCommand ?? ( _LoadCommand = new DelegateCommand<Canvas>(OnLoad) );

        private DelegateCommand _ColseCommand;

        public DelegateCommand ColseCommand => _ColseCommand ?? ( _ColseCommand = new DelegateCommand(OnClose) );

        private DelegateCommand _DataShowCommand;

        public DelegateCommand DataShowCommand => _DataShowCommand ?? ( _DataShowCommand = new DelegateCommand(OnShow) );

        private int _CurrentRegionWidth=350;
        
        public string Title
        {
            get { return _title; }
            set { SetProperty(ref _title, value); }
        }

        public int CurrentRegionWidth { get => _CurrentRegionWidth; set { SetProperty(ref _CurrentRegionWidth, value); } }


        private Thread RuningStart;

        public MainWindowViewModel(IContainerProvider container, IRegionManager regionManager)
        {
            _container = container;
            _regionManager= regionManager;


        }

        public void OnLoad(Canvas canvas)
        {
            RuningStart = new Thread(new ThreadStart(RunMethod));
            RuningStart.Name = "任务运行线程";
            RuningStart.IsBackground = true;
            Element   element=new Element("Start",_container);
            element.parentClass = _container.Resolve<StartService>();
            element._Name = "Start";
            element.SourcesName = "StartView";
            Canvas.SetTop(element.rect,10);
            canvas.Children.Add(element.rect);



            element=new Element("TcpClient",_container);
            element.parentClass = _container.Resolve<TcpClientService>();
            element._Name = "TcpClient";
            element.SourcesName = "TcpClientView";
            Canvas.SetTop(element.rect, element.rect.Height + 10);
            canvas.Children.Add(element.rect);



            element = new Element("TcpClientSend", _container);
            element.parentClass = _container.Resolve<TcpSendService>();
            element._Name = "TcpClientSend";
            element.SourcesName = "TcpClientSendView";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);

            element = new Element("TcpClientRcv", _container);
            element.parentClass = _container.Resolve<TcpRcvService>();
            element._Name = "TcpClientRcv";
            element.SourcesName = "TcpClientRcvView";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);

            element = new Element("TcpServer", _container);
            //element._iModule = _container.Resolve<TcpServerModule.Service>();
            element._Name = "TcpServer";
            element.SourcesName = "TcpServer";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);



            element = new Element("TcpModbusMaster", _container);
            //element._iModule = _container.Resolve<TcpModbusMasterModule.Service>();
            element._Name = "TcpModbusMaster";
            element.SourcesName = "TcpModbusMaster";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);


            element = new Element("TcpModbusSlave", _container);
            //element._iModule = _container.Resolve<TcpModbusSlaveModule.Service>();
            element._Name = "TcpModbusSlave";
            element.SourcesName = "TcpModbusSlave";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);


            element = new Element("TcpModbusSlave", _container);
            //element._iModule = _container.Resolve<TcpModbusSlaveModule.Service>();
            element._Name = "TcpModbusSlave";
            element.SourcesName = "TcpModbusSlave";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;

            element = new Element("Plc_S7", _container);
            // element._iModule = _container.Resolve<TcpModbusSlaveModule.Service>();

            element._Name = "Plc_S7";
            element.SourcesName = "S7NetView";
            element.parentClass = _container.Resolve<S7NetService>();
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;

            element = new Element("S7_读", _container);
            element.parentClass = _container.Resolve<S7ReadService>();
            element._Name = "S7_读";
            element.SourcesName = "S7ReadlView";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;






            element = new Element("S7_写", _container);
            element.parentClass = _container.Resolve<S7WriteService>();
            element._Name = "S7_写";
            element.SourcesName = "S7WriteView";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;

            element = new Element("自定义", _container);
            element.parentClass = _container.Resolve<CustomService>();
            element._Name = "自定义";
            element.SourcesName = "ViewA";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;


        }

        public void OnClose()
        {
            Application.Current.Shutdown();
            Thread.Sleep(100);
            Environment.Exit(0);
        }







        public void OnShow()
        {

            _regionManager.Regions[ "ContentRegion" ].RequestNavigate("LiveChartsView");
            if (RuningStart.ThreadState != ThreadState.Running)
            {
                StaticManualResetEvent.ManualisStopEvent.Set();
                RuningStart.Start();
            }
        }

       static TcpSocketClient tcpSocketClient = new TcpSocketClient();
        public void RunMethod()
        {



            tcpSocketClient.Connect("192.168.0.111", 2268);
            tcpSocketClient.StartReceive();
            tcpSocketClient.ReceiveData += TcpSocketClient_ReceiveData;
            LogHelper.Info("客户端已连接");


            S7Plc s7Plc = new S7Plc();
            s7Plc.model = new S7PlcModel() { IpAddress = "192.168.0.10", CpuType = S7.Net.CpuType.S71200, Port = 102, Rack = 0, Slot = 1 };
            s7Plc.Open();
            LogHelper.Info("Plc已连接");

            AsynchronousOneBufferedAI.Init();
            while (StaticManualResetEvent.ManualisStopEvent.WaitOne(100))
            {
                string str = "SOUR:CURR:SLEW:RIS 0.2\r\n";
                byte[] bytes = Encoding.Default.GetBytes(str);
                tcpSocketClient.Send(bytes);
                Thread.Sleep(200);
                 str = "SOUR:CURR:SLEW:FALL 0.2\r\n";
                bytes = Encoding.Default.GetBytes(str);
                tcpSocketClient.Send(bytes);
                bool res = true;
                while (StaticManualResetEvent.ManualisStopEvent.WaitOne(100))
                {
                    res = s7Plc.ReadBool(new S7ReadModel() { Db = 1090, StartByteAdr = 0, BitAdr = 0, VarCount = 1, VarType = S7.Net.VarType.Bit });
                    if (res)
                    {
                        Thread.Sleep(200);
                        AsynchronousOneBufferedAI.isEnd = true;
                        AsynchronousOneBufferedAI.RunTest();
                        Thread.Sleep(200);
                        bytes = Encoding.Default.GetBytes("OUTP ON\r\n");
                        tcpSocketClient.Send(bytes);
                        Thread.Sleep(1000);
                        bytes = Encoding.Default.GetBytes("OUTP OFF\r\n");
                        tcpSocketClient.Send(bytes);

                        break;
                    }
                    Thread.Sleep(50);
                }

                while (StaticManualResetEvent.ManualisStopEvent.WaitOne(100))
                {

                    if (!AsynchronousOneBufferedAI.isEnd)
                    {
                       
                        break;
                    }
                    Thread.Sleep(50);
                }
                Thread.Sleep(5000);
                continue;
                while (StaticManualResetEvent.ManualisStopEvent.WaitOne(100))
                {
                    s7Plc.WriteBool(new S7WriteModel() { Db = 1090, StartByteAdr = 6, BitAdr = 0, VarType = S7.Net.VarType.Bit, Value = true });
                    Thread.Sleep(100);
                    res = s7Plc.ReadBool(new S7ReadModel() { Db = 1090, StartByteAdr = 6, BitAdr = 0, VarCount = 1, VarType = S7.Net.VarType.Bit });
                    if (res)
                    {

                        break;
                    }
                    Thread.Sleep(50);
                }

               
                //Db2   262 string 


                while (StaticManualResetEvent.ManualisStopEvent.WaitOne(100))
                {
                    s7Plc.WriteBool(new S7WriteModel() { Db = 1090, StartByteAdr = 6, BitAdr = 1, VarType = S7.Net.VarType.Bit, Value = true });
                    Thread.Sleep(100);
                    res = s7Plc.ReadBool(new S7ReadModel() { Db = 1090, StartByteAdr = 6, BitAdr = 1, VarCount = 1, VarType = S7.Net.VarType.Bit });
                    if (res)
                    {
                        
                        break;
                    }
                    Thread.Sleep(50);
                }

               

                while (StaticManualResetEvent.ManualisStopEvent.WaitOne(100))
                {
                    res = s7Plc.ReadBool(new S7ReadModel() { Db = 1090, StartByteAdr = 0, BitAdr = 0, VarCount = 1, VarType = S7.Net.VarType.Bit });
                    if (!res)
                    {
                        break;
                    }
                    Thread.Sleep(50);
                }


                while (StaticManualResetEvent.ManualisStopEvent.WaitOne(100))
                {
                    s7Plc.WriteBool(new S7WriteModel() { Db = 1090, StartByteAdr = 6, BitAdr = 1, VarType = S7.Net.VarType.Bit, Value = false });
                    Thread.Sleep(100);
                    res = s7Plc.ReadBool(new S7ReadModel() { Db = 1090, StartByteAdr = 6, BitAdr = 1, VarCount = 1, VarType = S7.Net.VarType.Bit });
                    if (!res)
                    {

                        break;
                    }
                    Thread.Sleep(50);
                }

                while (StaticManualResetEvent.ManualisStopEvent.WaitOne(100))
                {
                    s7Plc.WriteBool(new S7WriteModel() { Db = 1090, StartByteAdr = 6, BitAdr = 0, VarType = S7.Net.VarType.Bit, Value = false });
                    Thread.Sleep(100);
                    res = s7Plc.ReadBool(new S7ReadModel() { Db = 1090, StartByteAdr = 6, BitAdr = 0, VarCount = 1, VarType = S7.Net.VarType.Bit });
                    if (!res)
                    {
                        Thread.Sleep(200);

                        break;
                    }
                    Thread.Sleep(50);
                }

                Thread.Sleep(50);
            }
        }

        private void TcpSocketClient_ReceiveData(System.Net.IPEndPoint remote, byte[] buffer, int count)
        {
            
        }
    }
}
