﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CommonUtils.内部存储
{
    public static class InternalStorage
    {

        private static Dictionary<string, bool> boolStorage = new Dictionary<string, bool>();

        private static Dictionary<string, byte> byteStorage = new Dictionary<string, byte>();

        private static Dictionary<string, int> intStorage = new Dictionary<string, int>();

        private static Dictionary<string, float> floatStorage = new Dictionary<string, float>();

        private static Dictionary<string, string> stringStorage = new Dictionary<string, string>();


        public static List<string> StorageTypes = new List<string>();
        public static List<string> StorageIndexs = new List<string>();

        public static double[] Buffs=new double[5000];

        public static bool ischange=false;



        public static void Init()
        {

            for (int i = 0; i < 20; i++)
            {
                boolStorage.Add("Bool" + i, false);
                byteStorage.Add("Byte" + i, new byte());
                intStorage.Add("Bool" + i, 0);
                floatStorage.Add("Float" + i, 0);
                stringStorage.Add("String" + i, "");
                StorageIndexs.Add(i.ToString());
            }

            StorageTypes.Add("无");
            StorageTypes.Add("Bool");
            StorageTypes.Add("Byte");
            StorageTypes.Add("Int");
            StorageTypes.Add("Float");
            StorageTypes.Add("String");

           
        }

        public static bool SetValue(string key, object vlaue)
        {
            string[] type = key.Split(':');

            switch (type[0])
            {
                case "Bool":
                    bool booltemp = false;
                    if (bool.TryParse((string?)vlaue, out booltemp))
                    {
                        SetBool(string.Concat(type), booltemp);
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                case "Byte":
                    SetByte(string.Concat(type), (byte)Convert.ChangeType(vlaue, typeof(byte)));
                    return true;
                case "Int":
                    int inttemp = 0;
                    if (int.TryParse((string?)vlaue, out inttemp))
                    {
                        SetInt(string.Concat(type), inttemp);
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                case "Float":
                    float floattemp = 0;
                    if (float.TryParse((string?)vlaue, out floattemp))
                    {
                        SetFloat(string.Concat(type), floattemp);
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                case "String":
                     SetString(string.Concat(type), (string)vlaue);
                     return true;
                default:
                    break;
            }

            return false;
        }

        public static object? GetValue(string key)
        {
            string[] type = key.Split(':');

            switch (type[0])
            {
                case "Bool":
                        return GetBool(string.Concat(type));
                case "Byte":
                        return GetByte(string.Concat(type));
                case "Int":
                        return GetInt(string.Concat(type));
                case "Float":
                        return GetFloat(string.Concat(type));
                case "String":
                        return GetString(string.Concat(type));
                default:
                    break;
            }

            return null;
        }

        public static void SetBool(string key, bool value)
        {
            boolStorage[key] = value;
        }

        public static bool GetBool(string key)
        {
            return boolStorage[key];
        }


        public static void SetByte(string key, byte value)
        {
            byteStorage[key] = value;
        }

        public static byte GetByte(string key)
        {
            return byteStorage[key];
        }

        public static void SetInt(string key, int value)
        {
            intStorage[key] = value;
        }

        public static int GetInt(string key)
        {
            return intStorage[key];
        }


        public static void SetFloat(string key, float value)
        {
            floatStorage[key] = value;
        }

        public static float GetFloat(string key)
        {
            return floatStorage[key];
        }
        public static void SetString(string key, string value)
        {
            stringStorage[key] = value;
        }

        public static string GetString(string key)
        {
            return stringStorage[key];
        }



    }
}
