﻿using FlowChartModule.Model;
using ParentService.ParentService;
using Prism.Ioc;
using Prism.Regions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace FlowChartModule.绘制模块
{
    public class Element
    {
        public Guid Id = Guid.NewGuid();


        public ParentClass parentClass;

        public Canvas rect;

        public string text;

        public string SourcesName;
        public DrawModule drawModule;

        public  Connection_Point up;
        public Connection_Point down;
        public  Connection_Point left;
        public Connection_Point right;
        public  List<Connection_Line> connection_Lines=new List<Connection_Line>();

        public IContainerProvider _container;
        public string _Name;
        #region  控件拖动判断

        public bool  isMouseDown=false;
        #endregion
        public Element(string name, IContainerProvider container,bool iscp=false, bool isLoad = true)
        {
            _container = container;
            rect = new Canvas();
            rect.Height = 50;
            rect.Width = 110;
            rect.Tag = this;
            Canvas.SetZIndex(rect,1);
            Rectangle rectangle = new Rectangle()
            {
                Width = 110,
                Height = 50,
                Fill = Brushes.LightBlue,
                Stroke = Brushes.Black,
                StrokeThickness = 2,
                RadiusX = 10,
                RadiusY = 10
            };
           
            rect.Children.Add(rectangle);
            if ( iscp )
            {
                up = new Connection_Point(new Point(( int ) ( rectangle.Width / 2 - 6 ), 0 - 6), rect, connection_Lines);
                down = new Connection_Point(new Point(( int ) ( rectangle.Width / 2 - 6 ), ( int ) rectangle.Height - 6), rect, connection_Lines);
                left = new Connection_Point(new Point(0 - 6, ( int ) ( rectangle.Height / 2 - 6 )), rect, connection_Lines);
                right = new Connection_Point(new Point(( int ) rectangle.Width - 6, ( int ) ( rectangle.Height / 2 - 6 )), rect, connection_Lines);
            }
            TextBlock  textBlock= new TextBlock()
            {
                Text = name,
                FontSize = 10,
                Width = 110,
                VerticalAlignment = VerticalAlignment.Center,
                HorizontalAlignment = HorizontalAlignment.Center,
                Foreground = Brushes.White,
            } ;
            Canvas.SetLeft(textBlock, 10);
            Canvas.SetTop(textBlock, 10);
            rect.Children.Add(textBlock);

            drawModule = container.Resolve<DrawModule>();
            if ( isLoad )
            {
                rect.MouseDown += Rect_MouseDown;
                rect.MouseUp += Rect_MouseUp;
            }

        }


       
        private void Rect_MouseUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            isMouseDown = false;
            drawModule.CurrentSelectElement = null;
        }

        private void Rect_MouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            isMouseDown = true;
            drawModule.CurrentSelectElement = this.Clone();
        }

        public void RequestNavigate(IRegionManager _regionManager)
        {
            _regionManager.RequestNavigate("ContentRegion", SourcesName);

        }
        public Element Clone()
        {
            Element element=new Element(this._Name,_container,true);
            element._Name = _Name;
            element.SourcesName = SourcesName;
            GetConcreteVisitor visitor = new GetConcreteVisitor(); // 创建访问者实例
            element.parentClass = parentClass.GetServices(visitor);
            element.rect.MouseUp -= element.Rect_MouseUp;
            element.rect.MouseDown -= element.Rect_MouseDown;
            return element;
        }

    }
}
