﻿using CustomModule.ViewModels;
using CustomModule.Views;
using Newtonsoft.Json;
using Prism.Ioc;
using S7NetModule.ViewModels;
using S7NetModule.Views;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ParentService.ParentService
{
    public class CustomService : ParentClass
    {
        [JsonIgnore]
        public IContainerProvider _container;

        private ViewAViewModel customViewModel=new ViewAViewModel();
        [JsonIgnore]
        private ViewA s7NetView;


        public ViewAViewModel CustomViewModel { get => customViewModel; set => customViewModel = value; }

        [JsonIgnore]
        public ViewA Custom_View
        {
            get
            {
                s7NetView = _container.Resolve<ViewA>();
                return s7NetView;
            }
            set => s7NetView = value;
        }

        public CustomService(IContainerProvider container)
        {

            _container = container;
        }
        public override void Accept(IVisitor visitor) { visitor.Visit(this); }

        public override bool AcceptRun(RunIVisitor visitor)
        {
            return visitor.RunVisit(this);
        }

        public override CustomService GetServices(IService visitor)
        {
            return visitor.GetService(this, _container);
        }
    }
}
