﻿using Newtonsoft.Json;
using Prism.Ioc;
using S7NetModule.ViewModels;
using S7NetModule.Views;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ParentService.ParentService
{
    public class S7NetService : ParentClass
    {
        [JsonIgnore]
        public IContainerProvider _container;

        private S7NetViewModel s7NetViewModel=new S7NetViewModel();
        [JsonIgnore]
        private S7NetView s7NetView;


        public S7NetViewModel S7ViewModel { get => s7NetViewModel; set => s7NetViewModel = value; }

        [JsonIgnore]
        public S7NetView S7_NetView
        {
            get
            {
                s7NetView = _container.Resolve<S7NetView>();
                return s7NetView;
            }
            set => s7NetView = value;
        }

        public S7NetService(IContainerProvider container) 
        {

            _container = container;
        }
        public override void Accept(IVisitor visitor) { visitor.Visit(this);  }

        public override bool AcceptRun(RunIVisitor visitor)
        {
            return visitor.RunVisit(this);
        }

        public override S7NetService GetServices(IService visitor)
        {
            return visitor.GetService(this, _container);
        }
    }
}
