﻿using Newtonsoft.Json;
using Prism.Ioc;
using S7NetModule.ViewModels;
using S7NetModule.Views;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TcpClientModule.ViewModels;
using TcpClientModule.Views;

namespace ParentService.ParentService
{
    public class TcpClientService : ParentClass
    {
        [JsonIgnore]
        public IContainerProvider _container;

        private TcpClientViewModel tcpClientViewModel=new TcpClientViewModel();
        [JsonIgnore]
        private TcpClientView tcpClientView;


        public TcpClientViewModel Tcp_ClientViewModel { get => tcpClientViewModel; set => tcpClientViewModel = value; }

        [JsonIgnore]
        public TcpClientView TcpClient_View
        {
            get
            {
                tcpClientView = _container.Resolve<TcpClientView>();
                return tcpClientView;
            }
            set => tcpClientView = value;
        }

        public TcpClientService(IContainerProvider container)
        {

            _container = container;
        }
        public override void Accept(IVisitor visitor) { visitor.Visit(this); }

        public override bool AcceptRun(RunIVisitor visitor)
        {
            return visitor.RunVisit(this);
            
        }

        public override TcpClientService GetServices(IService visitor)
        {
            return visitor.GetService(this, _container);
        }
    }
}