﻿using Newtonsoft.Json;
using Prism.Ioc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TcpClientModule.ViewModels;
using TcpClientModule.Views;

namespace ParentService.ParentService
{
    public class TcpRcvService : ParentClass
    {
        [JsonIgnore]
        public IContainerProvider _container;

        private TcpClientRcvViewModel tcpClientViewModel=new TcpClientRcvViewModel();
        [JsonIgnore]
        private TcpClientRcvView tcpRcvView;


        public TcpClientRcvViewModel Tcp_ClientRcvModel { get => tcpClientViewModel; set => tcpClientViewModel = value; }

        [JsonIgnore]
        public TcpClientRcvView TcpRcv_View
        {
            get
            {
                tcpRcvView = _container.Resolve<TcpClientRcvView>();
                return tcpRcvView;
            }
            set => tcpRcvView = value;
        }

        public TcpRcvService(IContainerProvider container)
        {

            _container = container;
        }
        public override void Accept(IVisitor visitor) { visitor.Visit(this); }

        public override bool AcceptRun(RunIVisitor visitor)
        {
            return visitor.RunVisit(this);
        }

        public override TcpRcvService GetServices(IService visitor)
        {
            return visitor.GetService(this, _container);
        }
    }
}
