﻿using Newtonsoft.Json;
using Prism.Ioc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TcpClientModule.ViewModels;
using TcpClientModule.Views;

namespace ParentService.ParentService
{
    public class TcpSendService : ParentClass
    {
        [JsonIgnore]
        public IContainerProvider _container;

        private TcpClientSendViewModel tcpClientViewModel=new TcpClientSendViewModel();
        [JsonIgnore]
        private TcpClientSendView tcpSendView;


        public TcpClientSendViewModel Tcp_ClientSendModel { get => tcpClientViewModel; set => tcpClientViewModel = value; }

        [JsonIgnore]
        public TcpClientSendView TcpSend_View
        {
            get
            {
                tcpSendView = _container.Resolve<TcpClientSendView>();
                return tcpSendView;
            }
            set => tcpSendView = value;
        }

        public TcpSendService(IContainerProvider container)
        {

            _container = container;
        }
        public override void Accept(IVisitor visitor) { visitor.Visit(this); }

        public override bool AcceptRun(RunIVisitor visitor)
        {
           return visitor.RunVisit(this);
        }

        public override TcpSendService GetServices(IService visitor)
        {
            return visitor.GetService(this, _container);
        }
    }
}
