﻿using FlowChartModule.Model;
using Prism.Ioc;
using Prism.Modularity;
using Prism.Regions;
using SettingModule.Views;

namespace SettingModule
{
    public class SettingModuleModule :IModule
    {
        
        public void OnInitialized(IContainerProvider containerProvider)
        {
            var regionManager = containerProvider.Resolve<RegionManager>();
            regionManager.RegisterViewWithRegion("ContentRegion", typeof(SettingView));
        }

        public void RegisterTypes(IContainerRegistry containerRegistry)
        {
            // 注册服务为单例
            containerRegistry.RegisterSingleton<Service>();
        }
        
    }
}