﻿using Prism.Ioc;
using Prism.Modularity;
using Prism.Regions;
using System.Configuration;
using TcpClientModule.Views;

namespace TcpClientModule
{
    public class TcpClientModuleModule : IModule
    {
        public void OnInitialized(IContainerProvider containerProvider)
        {
            var regionManager = containerProvider.Resolve<RegionManager>();
            regionManager.RegisterViewWithRegion("EditRegion", typeof(TcpClientView));
            regionManager.RegisterViewWithRegion("EditRegion", typeof(TcpClientSendView));
            regionManager.RegisterViewWithRegion("EditRegion", typeof(TcpClientRcvView));
        }

        public void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterSingleton<TcpClientView>();
            containerRegistry.RegisterSingleton<TcpClientSendView>();
            containerRegistry.RegisterSingleton<TcpClientRcvView>();

        }
    }
}