﻿using Prism.Ioc;
using Prism.Modularity;
using Prism.Regions;
using TcpServerModule.Views;

namespace TcpServerModule
{
    public class TcpServerModuleModule : IModule
    {
        public void OnInitialized(IContainerProvider containerProvider)
        {
            var regionManager = containerProvider.Resolve<RegionManager>();
            regionManager.RegisterViewWithRegion("ContentRegion", typeof(ViewA));
        }

        public void RegisterTypes(IContainerRegistry containerRegistry)
        {
            // 注册服务为单例
            containerRegistry.RegisterSingleton<Service>();
        }
    }
}